diff options
author | Gerald Carter <jerry@samba.org> | 2005-07-12 16:34:44 +0000 |
---|---|---|
committer | Gerald (Jerry) Carter <jerry@samba.org> | 2007-10-10 10:59:56 -0500 |
commit | b99ae5137471fad034dc7e98bc60cd2dc893b631 (patch) | |
tree | f1307088838e9490b1ed7a4e04f4eb8d9e330839 /examples/scripts/debugging/linux | |
parent | cfda53db8b22c7afbfae848506258f13ead041bf (diff) | |
download | samba-b99ae5137471fad034dc7e98bc60cd2dc893b631.tar.gz samba-b99ae5137471fad034dc7e98bc60cd2dc893b631.tar.bz2 samba-b99ae5137471fad034dc7e98bc60cd2dc893b631.zip |
r8384: merging clutter fixes from release branch
(This used to be commit cbe74c09109dcfe93aa4af085920999ccbff34df)
Diffstat (limited to 'examples/scripts/debugging/linux')
-rw-r--r-- | examples/scripts/debugging/linux/backtrace | 41 |
1 files changed, 41 insertions, 0 deletions
diff --git a/examples/scripts/debugging/linux/backtrace b/examples/scripts/debugging/linux/backtrace new file mode 100644 index 0000000000..2ea6a4d00a --- /dev/null +++ b/examples/scripts/debugging/linux/backtrace @@ -0,0 +1,41 @@ +#! /bin/sh +# +# Author: Andrew Tridgell <tridge at samba dot org> + +# we want everything on stderr, so the program is not disturbed +exec 1>&2 + +BASENAME=$( basename $0) + +test -z ${GDB_BIN} && GDB_BIN=$( type -p gdb) +if [ -z ${GDB_BIN} ]; then + echo "ERROR: ${BASENAME} needs an installed gdb. " + exit 1 +fi + +if [ -z $1 ]; then + echo "ERROR: ${BASENAME} needs a PID. " + exit 1 +fi +PID=$1 + +# use /dev/shm as default temp directory +test -d /dev/shm && \ + TMP_BASE_DIR=/dev/shm || \ + TMP_BASE_DIR=/var/tmp +TMPFILE=$( mktemp -p ${TMP_BASE_DIR} backtrace.XXXXXX) +if [ $? -ne 0 ]; then + echo "ERROR: ${basename} can't create temp file in ${TMP_BASE_DIR}. " + exit 1 +fi + +cat << EOF > "${TMPFILE}" +set height 0 +up 8 +bt full +quit +EOF + +${GDB_BIN} -x "${TMPFILE}" "/proc/${PID}/exe" "${PID}" + +/bin/rm -f "${TMPFILE}" |